<template>
  <div>
    <el-card v-for="(card, indexOfCard) in cards" :key="indexOfCard" class="card">
      <div class="layout">
        <div class="infoContainer">
          <div class="title">{{ card.title }}</div>
          <div class="description">{{ card.description }}</div>
        </div>
        <div class="timeContainer">
          <div class="currentTime">{{ card.currentTime }}</div>
        </div>
      </div>
      <div class="tags">
        <el-tag v-for="(tagcard, index) in card.tags" :key="'tagcard' + index" closable @close="closeTagFromCard(index, indexOfCard)" class="tagInCard">
        <span>{{ tagcard }}</span>
        </el-tag></div>
      <div>
        colors:
        <div v-for="(newColor, index) in tagsColors" :key="'newColor' + index" >
          {{ newColor }}
        </div>
      </div>
    </el-card>



    <el-card shadow="never">
      <el-input placeholder="title" @keyup.enter.native="focusOnDescription" ref="title" v-model="form.title"></el-input>
      <el-input placeholder="description" @keyup.enter.native="focusOnTagInput" ref="description" v-model="form.description"></el-input>
      <div>
        <el-input placeholder="# тэг" ref="tagInput" v-model="temporaryTag" @keyup.enter.native="addTemporaryTag" @keydown.enter.native="generateRandomTagColor"></el-input>
        <el-tag v-for="(formtag, index) in form.tags" :key="'formtag'+index" closable @close="deleteTag(index)">
          {{ formtag }}
        </el-tag>
      </div>
      <el-button @click="saveForm">saveForm</el-button>
      <div>
        общие ти:
        <el-tag v-for="(temporaryAllTag, index) in temporaryAllTags" :key="'allTag' + index" closable @click="addTagToForm(temporaryAllTag)">
          {{ temporaryAllTag }}
        </el-tag>
      </div>
    </el-card>
  </div>
</template>

<script>
export default {
  name: 'HelloWorld',
  data() {
    return {
      cards: [],
      allTags: [],
      temporaryAllTags: [],
      tagsColors: [],

      form: {
        title: '',
        description: '',
        createdAt: '',
        tags: [],
        tagsColors:[],
        currentTime: '',
      },

      temporaryTag:''
    }
  },
  methods: {
    returnDate() {
      let date = new Date();
      let timestamp = (date.getHours() < 10 ? '0' : '') + (date.getHours() + ':' + (date.getMinutes() < 10 ? '0' : '') + date.getMinutes());
      this.form.currentTime = timestamp;
    },

    saveForm() {
      this.returnDate();
      this.cards.push({
        ...this.form,
      });

      //добавить теги из формы во временные теги
      this.temporaryAllTags.push(...this.form.tags);

      //дбавить новые теги из временных в постоянные теги
      this.allTags = [...new Set(this.allTags.concat(this.temporaryAllTags))];
      this.clearForm();
      this.temporaryAllTags = (this.allTags);
    },
    //очистить форму
    clearForm() {
      this.$refs.title.focus();
      this.form.title = "";
      this.temporaryTag = "";
      this.form.description = "";
      this.form.tags = [];
    },
    //фокус на описании
    focusOnDescription() {
      this.$refs.description.focus();
    },
    //Фокус на поле тега
    focusOnTagInput() {
      this.$refs.tagInput.focus();
    },
    //Удалить тег нажав на крестик
    closeTagFromCard(index, indexOfCard) {
      this.cards[indexOfCard].tags.splice(index, 1);
    },
    //Добавить временный тег в форму
    addTemporaryTag() {
      if (this.temporaryTag.trim().length > 0) {
        this.form.tags.push(this.temporaryTag);
        this.form.tags = [...new Set(this.form.tags)];
        this.temporaryTag = "";

        //Генерируем случайный цвет для тега и кидаем его в массив
        let randomColor = '#' + Math.floor(Math.random() * 16777215).toString(16);
        this.tagsColors.push(randomColor);

        //Добавляем цвет в span, содержащий тег: нужно взять добавленный новый тег (только новый), и записать в массив цветов новый цвет. а в span где содержится этот тег надо записать background: и взять из массива цветов последний, который уже сгенерирован.

      }
    },

    addTagToForm(tag) {
        this.form.tags.push(tag);
        this.form.tags = [...new Set(this.form.tags)];
      },

    //generateRandomTagColor() {

        //this.form.tagsColors.push(newColor);
      //}
    }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" rel="stylesheets/scss" scoped>

  .card {

    .layout {
      display: flex;
      flex-direction: row;
      width: 100%;


      .infoContainer {
        display: flex;
        flex-direction: column;
        width: 100%;

        .title {
          font-weight: bold;
          text-align: left;
          font-size: large;
        }

        .description {
          text-align: left;
          font-size: medium;
        }

      }

      .timeContainer {
        display: flex;
        flex-basis: 10%;
        line-height: 2;
        font-size: 2em;

        .currentTime {
        }

      }

    }
    .tags {

          }
  }

</style>
